#!/usr/bin/perl

####################################################################
# MyCalendar email script version 1.4 
# (many bugs fixed)
#
#This software is released under the GPL.  Please
#see the included LICENSE file.
#
#Copyright (C) 2001  Michael Spiceland
#Copyright (C) 2001  Jay Kline
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#Use this script at your own risk!  I make no 
#warranties that it is hack proof!
#
#
# This script is part of Mike's Perl Script Archive at
# www.mikespice.com/perl/
#
####################################################################


#My Calendar email script (quick hack)
#edit the variables below.  $previous_days is the number of days in advance
#that you would like to receive an email notification.  The emails are the to 
#and from addresses to use when sending the email notifications.

$previous_days = "1";
$to_email = 'mike@fuzzymonkey.org';
$from_email = 'mike@fuzzymonkey.org';
$sendmail = '/usr/lib/sendmail';

require "sitevariables.pl";

#get current day, month, year and stuff
($sec,$min,$hr,$mday,$mon,$year_localtime,$wday,$yday,$isdst) = localtime(time());
$year = $year_localtime + 1900;
$month = $mon + 1;
$day = $mday; #oops
@pretty_months = ("","January","Febuary","March","April","May","June","July","August","September","October","November","December");

#read in this months appointments
%apps = get_appointments($month,$year);

#check to see if any appointments are coming up and if so, send an email
$day = $day + $previous_days;
if($apps{"$day"}){
	$appointments = $apps{"$day"};
	$appointments =~ s/##/\n\n/g;
	$subject = "[$title] reminder";
	$body = "Reminder from the $title calendar:\n\nThese events will occur in the next $previous_days days:\n\n$appointments\n\nThank you,\n$title";
	email($subject,$to_email,$from_email,$subject,$body);
}

sub get_appointments($$){
        my $app_day;
        my $app;
        my %apps;
        if (open(INFILE, "$_[0]-$_[1].txt")){
                while(<INFILE>){
                        chomp;
                        ($app_day,$app) = split(/\t/,"$_");
                        $apps{"$app_day"} = "$app";
                }
                close INFILE;
        }

        return %apps;
}

sub email($$$$$){
    my ($subject, $to, $from, $etitle, $body) = @_;

    open (MAIL, "| $sendmail -i -t" ) || die("could not open mail");
    print MAIL <<MAIL_MESSAGE;
Subject:$subject
To:$to
Reply-to:$from
From:$etitle
$body
MAIL_MESSAGE
     close MAIL;
}

